import serial
import time
import sys

#ser = serial.Serial()


def OpenBluetooth(pt):
    global ser
    s = '\\\\.\\COM%d' % pt
    ser = serial.Serial(port=s,\
                        baudrate=9600,\
                        parity=serial.PARITY_NONE,\
                        stopbits=serial.STOPBITS_ONE,\
                        bytesize=serial.EIGHTBITS,\
                        timeout=1)
    #TODO: add checking to ensure port is open

#def ReadBluetooth():
#    line = ser.readline().rstrip()
#    return line;

def LEDWrite(i):
    s = 'LEDWrite {0}\n'.format(i)
    ser.write(s.encode())
    return;

def LEDOn(i):
    s = 'LEDOn {0}\n'.format(i)
    ser.write(s.encode())
    return;

def LEDOff(i):
    s = 'LEDOff {0}\n'.format(i)
    ser.write(s.encode())
    return;

def SetServo(a,b):
    s = 'SetServo {0} {1}\n'.format(a,b)
    ser.write(s.encode())
    try:
        r = int(ser.readline().rstrip())
    except ValueError:
        print("Bad return!")
        raise
    return(r);

def SetAllServos(a,b,c,d,e):
    s = 'SetAllServos {0} {1} {2} {3} {4}\n'.format(a,b,c,d,e)
    ser.write(s.encode())
    try:
        r = int(ser.readline().rstrip())
    except ValueError:
        print("Bad return!")
        raise
    return(r);

def GripperClose(i):
    s = 'GripperClose {0}\n'.format(i)
    ser.write(s.encode())
    try:
        r = int(ser.readline().rstrip())
    except ValueError:
        print("Bad return!")
        raise
    return(r);

def GripperOpen():
    s = 'GripperOpen\n'
    ser.write(s.encode())
    try:
        r = int(ser.readline().rstrip())
    except ValueError:
        print("Bad return!")
        raise
    return(r);

def Park():
    s = 'Park\n'
    ser.write(s.encode())
    try:
        r = int(ser.readline().rstrip())
    except ValueError:
        print("Bad return!")
        raise
    return(r);

def StoreCoords(a,b,c,d,e,f):
    s = 'StoreCoords {0} {1} {2} {3} {4} {5}\n'.format(a,b,c,d,e,f)
    ser.write(s.encode())
    return;

def StorePosition(a):
    s = 'StorePosition {0}\n'.format(a)
    ser.write(s.encode())
    return;

def GotoPosition(a):
    s = 'GotoPosition {0}\n'.format(a)
    ser.write(s.encode())
    try:
        r = int(ser.readline().rstrip())
    except ValueError:
        print("Bad return!")
        raise
    return(r);

def ReadSwitch(a):
    s = 'ReadSwitch {0}\n'.format(a)
    ser.write(s.encode())
    try:
        r = int(ser.readline().rstrip())
    except ValueError:
        print("Bad return!")
        raise
    return(r);

def ReadLight():
    s = 'ReadLight\n'
    ser.write(s.encode())
    try:
        r = int(ser.readline().rstrip())
    except ValueError:
        print("Bad return!")
        raise
    return(r);

def ReadPot():
    s = 'ReadPot\n'
    ser.write(s.encode())
    try:
        r = int(ser.readline().rstrip())
    except ValueError:
        print("Bad return!")
        raise
    return(r);

def ReadPressure():
    s = 'ReadPressure\n'
    ser.write(s.encode())
    try:
        r = int(ser.readline().rstrip())
    except ValueError:
        print("Bad return!")
        raise
    return(r);

def ReadMagnet():
    s = 'ReadMagnet\n'
    ser.write(s.encode())
    try:
        r = int(ser.readline().rstrip())
    except ValueError:
        print("Bad return!")
        raise
    return(r);

def ReadColour():
    s = 'ReadColour\n'
    ser.write(s.encode())
    try:
        r = int(ser.readline().rstrip())
    except ValueError:
        print("Bad return!")
        raise
    return(r);
    
def ReadColourChannel(a,b):
    s = 'ReadColourChannel {0} {1}\n'.format(a,b)
    ser.write(s.encode())
    try:
        r = int(ser.readline().rstrip())
    except ValueError:
        print("Bad return!")
        raise
    return(r);

def Beep (a,b,c):
    s = 'Beep {0} {1} {2}\n'.format(a,b,c)
    ser.write(s.encode())
    try:
        r = int(ser.readline().rstrip())
    except ValueError:
        print("Bad return!")
        raise
    return;

def LCDClear():
    s = 'LCDClear\n'
    ser.write(s.encode())
    return;

def LCDPrint(i):
    s = 'LCDPrint {0}\n'.format(i)
    ser.write(s.encode())
    return;

def LCDNumber(i):
    s = 'LCDNumber {0}\n'.format(i)
    ser.write(s.encode())
    return;

def LCDCursor(x,y):
    s = 'LCDCursor {0} {1}\n'.format(x,y)
    ser.write(s.encode())
    return;

def LCDClearLine(i):
    s = 'LCDClearLine {0}\n'.format(i)
    ser.write(s.encode())
    return;



